package info.bukova.isspst.services;

import java.util.Date;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import info.bukova.isspst.dao.BaseDao;
import info.bukova.isspst.data.DataModel;

public abstract class AbstractService<T extends DataModel> implements Service<T> {

	protected BaseDao<T> dao;
	
	public void setDao(BaseDao<T> dao) {
		this.dao = dao;
	}
	
	@Override
	@Transactional
	public void add(T entity) {
		entity.setCreated(new Date());
		dao.add(entity);
	}

	@Override
	@Transactional
	public void update(T entity) {
		entity.setModified(new Date());
		dao.modify(entity);
	}

	@Override
	@Transactional
	public void delete(T entity) {
		dao.delete(entity);
	}

	@Override
	public List<T> getAll() {
		return dao.getAll();
	}

	@Override
	public List<T> execQuery(String query) {
		return dao.execQuery(query);
	}

	@Override
	public T selectSingle(String query) {
		return null;
	}

}
