package info.bukova.isspst.services;

import org.hibernate.Query;
import org.springframework.security.authentication.encoding.PasswordEncoder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.transaction.annotation.Transactional;

import info.bukova.isspst.data.User;

public class UserServiceImpl extends AbstractService<User> implements UserService, UserDetailsService {

	private PasswordEncoder encoder;
	
	public void setEncoder(PasswordEncoder encoder) {
		this.encoder = encoder;
	}
	
	@Override
	@Transactional
	public UserDetails loadUserByUsername(String username)
			throws UsernameNotFoundException {
		
		Query q = dao.getQuery("from User user where user.username = :username");
		q.setString("username", username);
		User u = (User) q.uniqueResult();
		
		if (u == null)
			throw new UsernameNotFoundException("User " + username + " not found");
		
		return u;
	}

	@Override
	public void setPassword(User user, String password) {
		user.setPassword(encoder.encodePassword(password, user.getUsername()));
	}


}
